Draft BSpline

From FreeCAD Documentation
Jump to navigation Jump to search
This page contains changes which are not marked for translation.
Under construction icon-blue.svg
This documentation is work in progress. Please don't mark it as translatable since it will change the next hours and days.
Other languages:
Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎svenska • ‎čeština • ‎русский
Arrow-left.svg Previous: Draft Polygon.svg Polygon

Draft BSpline.svg Draft BSpline

Menu location
Drafting → B-spline
Workbenches
Draft, Arch
Default shortcut
B S
Introduced in version
0.7
See also
Draft Wire, Draft CubicBezCurve, Draft BezCurve

Description

The Draft BSpline.svg Draft BSpline command creates a B-spline curve from several points. It uses the Draft Linestyle set on the Draft Tray.

The Draft BSpline command specifies the exact points through which the curve will pass. The Draft BezCurve and the Draft CubicBezCurve commands, on the other hand, use control points to define the position and curvature of the spline.

Draft bspline example.jpg

Spline defined by multiple points

Usage

  1. There are several ways to invoke the command:
    • Press the Draft BSpline.svg Draft BSpline button.
    • Select the Drafting → Draft BSpline.svg B-spline option from the menu.
    • Use the keyboard shortcut: B then S.
  2. Click the first point in the 3D view, or type coordinates and press the Draft AddPoint.svg Enter point button in the related Line task panel.
  3. Click additional points in the 3D view, or type coordinates and press the Draft AddPoint.svg Enter point button in the related Line task panel.
  4. Press Esc or the Close button in the related Line task panel to finish the command.

Options

  • Press A or the Draft FinishLine.svg Finish button to finish the spline, leaving it open.
  • Press O or the Draft CloseLine.svg Close button to close the spline, that is, a curve will be added from the last point to the first one to form a face. At least three points are required to form a face.
  • Press W or the Draft Wipe.svg Wipe button to remove the curve segments already placed, but keep editing the spline from the last point.
  • Press U or the Draft SelectPlane.svg Set WP button to adjust the current working plane in the orientation of the last point.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component. You can press the Draft AddPoint.svg Enter point button when you have the desired values to insert the point.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the BSpline command will restart after you finish the spline, allowing you to draw another one without pressing the command button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, a closed spline will create a filled face (DataMake Face true); if not, the closed spline will not make a face (DataMake Face false).
Note: the spline should not be filled if it intersects itself, as it won't create a proper face. If the spline is filled but no shape is visible, manually set DataMake Face to false to see the spline.
  • Hold Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Hold Shift while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press Ctrl+Z or press the Draft UndoLine.svg Undo button to undo the last point.
  • Press Esc or the Close button to abort the current command; curve segments already placed will remain.

Notes

Properties

See also: Property editor.

A Draft BSpline object is derived from a Part Part2DObject and inherits all its properties. It also has the following additional properties:

Data

  • DataArea (Area): (read-only) specifies the area of the face of the spline. The value will be 0.0 if DataMake Face if false or the face cannot be created.
  • DataClosed (Bool): specifies if the spline is closed or not. If the spline is initially open this value is false, setting it to true will draw a curve segment to close the spline. If the spline is initially closed this value is true, setting it to false will remove the last curve segment and make the spline open.
  • DataMake Face (Bool): specifies if the spline makes a face or not. If it is true a face is created, otherwise only the perimeter is considered part of the object. This property only works if DataClosed is true and if the spline does not self-intersect.
  • DataParameterization (Float): affects the shape of the spline.
  • DataPoints (VectorList): specifies the points of the spline in its local coordinate system.

View

  • ViewArrow Size (Length): specifies the size of the symbol displayed at the end of the spline.
  • ViewArrow Type (Enumeration): specifies the type of symbol displayed at the end of the spline, which can be Dot, Circle, Arrow, Tick or Tick-2.
  • ViewEnd Arrow (Bool): specifies whether to show a symbol at the end of the spline, so it can be used as an annotation line.
  • ViewPattern (Enumeration): specifies the Draft Pattern with which to fill the face of the closed spline. This property only works if DataMake Face is true and if ViewDisplay Mode is Flat Lines.
  • ViewPattern Size (Float): specifies the size of the Draft Pattern.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a Draft BSpline use the make_bspline method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeBSpline method.

bspline = make_bspline(pointslist, closed=False, placement=None, face=None, support=None)
bspline = make_bspline(Part.Wire, closed=False, placement=None, face=None, support=None)
  • Creates a bspline object from the given list of points, pointslist.
    • Each point in the list is defined by its FreeCAD.Vector, with units in millimeters.
    • Alternatively, the input can be a Part.Wire, from which points are extracted.
  • If closed is True, or if the first and last points are identical, the wire is closed.
  • If placement is None the shape is created at the origin.
  • If face is True, and the spline is closed, the spline will make a face, that is, it will appear filled.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(2000, 0, 0)

spline1 = Draft.make_bspline([p1, p2, p3], closed=False)
spline2 = Draft.make_bspline([p1, 2*p3, 1.3*p2], closed=False)
spline3 = Draft.make_bspline([1.3*p3, p1, -1.7*p2], closed=False)

doc.recompute()


Arrow-left.svg Previous: Draft Polygon.svg Polygon